/* ExEf - the ultimate effect engine
Copyright (C) 2001-2003 Tom Olexa <olexat@post.cz> */

#ifndef AFMT_S32_LE
#define AFMT_S32_LE              0x00008000
#endif

#define BUF_SIZE 1024 /* fragment length in samples */
#define X 4
#define Y 10

void DesignPass(char ftion, short freq, float sg);
void DesignBiquad(char ftion, short freq, float Q, float sg);
void DesignReverb(short ord, unsigned short implen, unsigned short pre, unsigned short tau);

void Signals();
void Errors();
void SaveToDisk();
void InEof();

void CmdLine(int argc, char **argv, char **file, char **infile);
void ClrUarray();
void CreateBox(short x,short y,char kind);
void LoadBox(char *str,short x,short y,char kind);
void ChangeBox(short x, short y, char kind);
void InsertBox(short x, short y);
void RemoveBox(short x, short y);
void RemoveColumn(short x);
void RemoveAll();
void HomeDir(char *dir);
void ReadColumn(FILE *strm, short x);
int ReadConfig(char *path);
void ReadSingleColumn(char *path, short x);

void realtime();
void opencard();

void IniTmp();
void OpenTcl();

void fft(float *real, float *imag);
void FGain(short x, short y);
void FPass(short x, short y);
void FBiquad(short x, short y);
void FDistort(short x, short y);
void FHalf(short x, short y);
void FModulator(short x, short y);
void FDelay(short x, short y);
void FHall(short x, short y);
void FReverb(short x, short y);
void FCompressor(short x, short y);
void FQuant(short x, short y);
void FNoiseGate(short x, short y);
void FSpecSubF(short x, short y);
void FSinGen(short x, short y);
void FWNoise(short x, short y);
void FCopyToNextColumn(short x);
void FInterVU(short x);
void SelChan();
void EstPower(float *sig, float *power, int *over, float lambda);
void EvalCommand();
void ReadCommand();
void effect();

void SaveWave();
void checkout();
void writefrag();
int readfrag();
void play();

int main(int argc, char **argv);


typedef
    struct struct_SavedPage {
	struct struct_SavedPage *next;
	int seconds;
	int millisecs;
	short data[1];
	long data_32[1];
    } SavedPage;

typedef
    struct {
	char KindOfBox;
	void *LinkToBox;
    } Box;

typedef     
    struct {
	float g;
    } Gain;

typedef 
    struct {
	float b0,b1,a1,d1;
    } Pass;

typedef     
    struct {
	float a1,a2,b0,b1,b2,d1,d2;
    } Biquad;
     
typedef
    struct {
	char lftion;
	char rftion;
	float pd;
    } Distort;

typedef
    struct {
	float prev[BUF_SIZE];
	float pd;
    } Half;

typedef
    struct {
	char ftion;
	char wave;
	short depth,period;
	float pd;
	float prev[BUF_SIZE];
	float PrevGen,d1;
    } Modulator;

typedef
    struct {
	short reset;
	unsigned short i; 
	unsigned short pre,d1,d2;
	float R1,R2;
	float output;
	float D[65536];
    } Delay;

typedef
    struct {
	short reset;
	unsigned short i; 
	unsigned short pre,d1,d2,d3;
	float R1,R2,R3;
	float output;
	float D[65536];
    } Hall;

typedef
    struct {
	short reset;
	unsigned short i;
	short ord; 
	unsigned short Bi[100];
	float Bv[100];
	unsigned short fbtime;
	float fbk,output;
	float D[65536];
    } Reverb;

typedef
    struct {
	float lambda,thresh,ratio,clambda,dlambda,powerp,gp;
    } Compressor; 

typedef
    struct {
	float levels;
    } Quant;

typedef
    struct {
	float lambda,threshp,saturp,clambda,dlambda,powerp,gp;
    } NoiseGate;

typedef
    struct {
	float thresh,lambda,time;
	short limit;
	float Noise[BUF_SIZE];
	float PrevSig[BUF_SIZE>>1];
	float PrevClean[BUF_SIZE>>1];
    } SpecSubF;

typedef
    struct {
	short freq;
	float prev,pd;
    } SinGen;
     
typedef
    struct {
	float pd;
    } WNoise;
